/*      -*- OpenSAF  -*-
 *
 * (C) Copyright 2008 The OpenSAF Foundation
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. This file and program are licensed
 * under the GNU Lesser General Public License Version 2.1, February 1999.
 * The complete license can be accessed from the following location:
 * http://opensource.org/licenses/lgpl-license.php
 * See the Copying file included with the OpenSAF distribution for full
 * licensing terms.
 *
 * Author(s): Emerson Network Power
 *
 */

/*****************************************************************************
..............................................................................

..............................................................................

  DESCRIPTION:  MDS layer initialization and destruction entry points

  ******************************************************************************
  */

#ifndef MDS_MDS_DL_API_H_
#define MDS_MDS_DL_API_H_

#include "base/ncs_lib.h"

#ifdef __cplusplus
extern "C" {
#endif

uint32_t mds_lib_req(NCS_LIB_REQ_INFO *req);
int mds_auth_server_connect(const char *name, MDS_DEST mds_dest, int svc_id,
                            int64_t timeout);
int mds_auth_server_disconnect(const char *name, MDS_DEST mds_dest, int svc_id,
                               int64_t timeout);
int mds_auth_server_create(const char *name);

#ifdef __cplusplus
}
#endif

#endif  // MDS_MDS_DL_API_H_
